#include <windows.h>

#include <cstdio>
#include <cstring>
#include <string>

using namespace std;

#include "stdtrim.h"
#include "hddutil.h"

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

bool   _isNT();
void   _swapOrder(PCHAR szString, USHORT uscStrSize);

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

string GetPrimaryHDDSerial()
{
    static string       _result;

    string              ModelNo;
    string              DiskSN;
    SENDCMDINPARAMS     in  = {0};
    uSENDCMDOUTPARAMS   out = {0};
    HANDLE              hIO;
    DWORD               cnt;

    _result.clear();

    if ( _isNT() == true )
    {
        PIDSECTOR phdinfo = {0};

        char tmpstr[41] = {0};

        hIO = CreateFile( "\\\\.\\PhysicalDrive0",
                          GENERIC_READ|GENERIC_WRITE,
                          FILE_SHARE_READ|FILE_SHARE_WRITE,
                          0,
                          OPEN_EXISTING,
                          0,
                          0 );
        if ( hIO == NULL )
            return _result;

        in.irDriveRegs.bDriveHeadReg    = 0xa0;
        in.irDriveRegs.bCommandReg      = 0xec;
        in.bDriveNumber                 = 0;
        in.irDriveRegs.bSectorCountReg  = 1;
        in.irDriveRegs.bSectorNumberReg = 1;
        in.cBufferSize                  = 512;

        BOOL bSucc = DeviceIoControl( hIO,
                                      DFP_RECEIVE_DRIVE_DATA,
                                      &in,
                                      sizeof(in),
                                      &out,
                                      sizeof(out),
                                      &cnt,
                                      0 );
        if ( bSucc == FALSE )
        {
            CloseHandle( hIO );
            return _result;
        }

        phdinfo = (PIDSECTOR)out.bBuffer;

        strncpy( tmpstr, phdinfo->sModelNumber, 40 );
        _swapOrder( tmpstr,40 );
        ModelNo = tmpstr;
        ZeroMemory( tmpstr, 41 );

        strncpy( tmpstr, phdinfo->sSerialNumber, 20 );
        _swapOrder( tmpstr, 20 );
        DiskSN = tmpstr;

        _result  = trim( ModelNo );
        _result += "-";
        _result += trim( DiskSN );

        CloseHandle( hIO );
    }
    else
    {
        hIO = CreateFile( "\\\\.\\Smartvsd",
                          0,
                          0,
                          0,
                          CREATE_NEW,
                          0,
                          0 );
        if ( hIO == NULL )
        {
            return _result;
        }

        //Identify the IDE drives
        PIDSECTOR phdinfo = {0};
        char tmpstr[41] = {0};

        in.irDriveRegs.bDriveHeadReg    = 0xa0;
        in.irDriveRegs.bCommandReg      = 0xec;
        in.bDriveNumber                 = 0;
        in.irDriveRegs.bSectorCountReg  = 1;
        in.irDriveRegs.bSectorNumberReg = 1;
        in.cBufferSize                  = 512;

        BOOL bSucc = DeviceIoControl( hIO,
                                      DFP_RECEIVE_DRIVE_DATA,
                                      &in,
                                      sizeof(in),
                                      &out,
                                      sizeof(out),
                                      &cnt,
                                      0 );
        if ( bSucc == FALSE )
        {
            CloseHandle( hIO );
            return _result;
        }

        phdinfo = (PIDSECTOR)out.bBuffer;

        strncpy( tmpstr, phdinfo->sModelNumber, 40 );
        _swapOrder( tmpstr, 40 );
        ModelNo = tmpstr;
        ZeroMemory( tmpstr, 41 );

        strncpy( tmpstr, phdinfo->sSerialNumber, 20 );
        _swapOrder( tmpstr, 20 );
        DiskSN = tmpstr;

        CloseHandle( hIO );

        _result  = trim( ModelNo );
        _result += "-";
        _result += trim( DiskSN );
    }

    if ( _result.size() == 0 )
    {
        // If it failed to read serial number, it need to use volume serial of MBR.
        _result = GetHDDVolumeSerial();
    }

    return _result;
}

bool _isNT()
{
    OSVERSIONINFO sInfo = {sizeof(OSVERSIONINFO),0};

    GetVersionEx(&sInfo);

    if ( sInfo.dwMajorVersion >= 5 )
    {
        return true;
    }

    return false;
}

void _swapOrder(PCHAR szString, USHORT uscStrSize)
{
    for (int cnt = 0; cnt< uscStrSize; cnt+=2)
    {
        char temp       = szString[cnt];
        szString[cnt]   = szString[cnt+1];
        szString[cnt+1] = temp;
    }
}

string GetHDDVolumeSerial( const char* refpath )
{
    static string   _result;

    char            drvRoot[4] = "C:\\";
    DWORD           volSerial  = 0x0;

    if ( refpath != NULL )
    {
        if ( strlen( refpath ) >= 4 )
        {
            strncpy( drvRoot, refpath, 4 );
        }
    }

    _result.clear();

    BOOL bSucc = GetVolumeInformation( drvRoot,
                                       NULL,
                                       0,
                                       &volSerial,
                                       NULL,
                                       NULL,
                                       NULL,
                                       0 );

    if ( bSucc == TRUE )
    {
        char tmpmap[32] = {0};
         sprintf( tmpmap, "%0X", volSerial );
        _result = tmpmap;
    }

    return _result;
}
